Index: uspace/drv/bus/usb/uhci/uhci_batch.h
===================================================================
--- uspace/drv/bus/usb/uhci/uhci_batch.h	(revision d2d142afa611111d7d295ad56a4f3bba24d607f2)
+++ uspace/drv/bus/usb/uhci/uhci_batch.h	(revision f9d0a86c86defda4d9f30fbb4f7217a75048bf8b)
@@ -43,4 +43,5 @@
 #include <stddef.h>
 #include <usb/host/usb_transfer_batch.h>
+#include <usb/host/endpoint.h>
 
 #include "hw_struct/queue_head.h"
@@ -49,4 +50,6 @@
 /** UHCI specific data required for USB transfer */
 typedef struct uhci_transfer_batch {
+	usb_transfer_batch_t base;
+
 	/** Queue head
 	 * This QH is used to maintain UHCI schedule structure and the element
@@ -60,13 +63,13 @@
 	/** Data buffer, must be accessible by the UHCI hw */
 	void *device_buffer;
-	/** Generic transfer data */
-	usb_transfer_batch_t *usb_batch;
 	/** List element */
 	link_t link;
 } uhci_transfer_batch_t;
 
-uhci_transfer_batch_t * uhci_transfer_batch_get(usb_transfer_batch_t *batch);
-void uhci_transfer_batch_finish_dispose(uhci_transfer_batch_t *uhci_batch);
-bool uhci_transfer_batch_is_complete(const uhci_transfer_batch_t *uhci_batch);
+uhci_transfer_batch_t * uhci_transfer_batch_create(endpoint_t *);
+int uhci_transfer_batch_prepare(uhci_transfer_batch_t *);
+bool uhci_transfer_batch_check_completed(uhci_transfer_batch_t *);
+void uhci_transfer_batch_finish(uhci_transfer_batch_t *);
+void uhci_transfer_batch_destroy(uhci_transfer_batch_t *);
 
 /** Get offset to setup buffer accessible to the HC hw.
@@ -91,21 +94,6 @@
 {
 	assert(uhci_batch);
-	assert(uhci_batch->usb_batch);
 	return uhci_transfer_batch_setup_buffer(uhci_batch) +
-	    uhci_batch->usb_batch->setup_size;
-}
-
-/** Aborts the batch.
- * Sets error to EINTR and size off transferd data to 0, before finishing the
- * batch.
- * @param uhci_batch Batch to abort.
- */
-static inline void uhci_transfer_batch_abort(uhci_transfer_batch_t *uhci_batch)
-{
-	assert(uhci_batch);
-	assert(uhci_batch->usb_batch);
-	uhci_batch->usb_batch->error = EINTR;
-	uhci_batch->usb_batch->transfered_size = 0;
-	uhci_transfer_batch_finish_dispose(uhci_batch);
+	    (uhci_batch->base.ep->transfer_type == USB_TRANSFER_CONTROL ? USB_SETUP_PACKET_SIZE : 0);
 }
 
@@ -120,4 +108,10 @@
 }
 
+static inline uhci_transfer_batch_t *uhci_transfer_batch_get(usb_transfer_batch_t *b)
+{
+	assert(b);
+	return (uhci_transfer_batch_t *) b;
+}
+
 #endif
 
Index: uspace/drv/bus/usb/uhci/uhci_rh.c
===================================================================
--- uspace/drv/bus/usb/uhci/uhci_rh.c	(revision d2d142afa611111d7d295ad56a4f3bba24d607f2)
+++ uspace/drv/bus/usb/uhci/uhci_rh.c	(revision f9d0a86c86defda4d9f30fbb4f7217a75048bf8b)
@@ -39,4 +39,5 @@
 #include <usb/classes/hub.h>
 #include <usb/request.h>
+#include <usb/host/endpoint.h>
 #include <usb/usb.h>
 
@@ -103,11 +104,7 @@
 	assert(batch);
 
-	const usb_target_t target = {{
-		.address = batch->ep->address,
-		.endpoint = batch->ep->endpoint
-	}};
 	do {
-		batch->error = virthub_base_request(&instance->base, target,
-		    usb_transfer_batch_direction(batch), (void*)batch->setup_buffer,
+		batch->error = virthub_base_request(&instance->base, batch->target,
+		    batch->dir, (void*) batch->setup.buffer,
 		    batch->buffer, batch->buffer_size, &batch->transfered_size);
 		if (batch->error == ENAK)
@@ -116,6 +113,5 @@
 		//ENAK is technically an error condition
 	} while (batch->error == ENAK);
-	usb_transfer_batch_finish(batch, NULL);
-	usb_transfer_batch_destroy(batch);
+	usb_transfer_batch_finish(batch);
 	return EOK;
 }
Index: uspace/drv/bus/usb/usbhub/port.c
===================================================================
--- uspace/drv/bus/usb/usbhub/port.c	(revision d2d142afa611111d7d295ad56a4f3bba24d607f2)
+++ uspace/drv/bus/usb/usbhub/port.c	(revision f9d0a86c86defda4d9f30fbb4f7217a75048bf8b)
@@ -40,4 +40,5 @@
 #include <inttypes.h>
 #include <fibril_synch.h>
+#include <usbhc_iface.h>
 
 #include <usb/debug.h>
@@ -267,5 +268,5 @@
 	if (!exch)
 		return ENOMEM;
-	const int rc = usb_device_remove(exch, port->port_number);
+	const int rc = usbhc_device_remove(exch, port->port_number);
 	usb_device_bus_exchange_end(exch);
 	if (rc == EOK)
@@ -405,5 +406,5 @@
 
 	/* Reserve default address */
-	while ((ret = usb_reserve_default_address(exch, speed)) == ENOENT) {
+	while ((ret = usbhc_reserve_default_address(exch, speed)) == ENOENT) {
 		async_usleep(1000000);
 	}
@@ -421,5 +422,5 @@
 		usb_log_error("(%p-%u): Failed to reset port.", hub,
 		    port->port_number);
-		if (usb_release_default_address(exch) != EOK)
+		if (usbhc_release_default_address(exch) != EOK)
 			usb_log_warning("(%p-%u): Failed to release default "
 			    "address.", hub, port->port_number);
@@ -430,5 +431,5 @@
 	    port->port_number);
 
-	ret = usb_device_enumerate(exch, port->port_number);
+	ret = usbhc_device_enumerate(exch, port->port_number);
 	if (ret != EOK) {
 		usb_log_error("(%p-%u): Failed to enumerate device: %s", hub,
@@ -440,5 +441,5 @@
 			    port->port_number, str_error(ret));
 		} else {
-			const int ret = usb_release_default_address(exch);
+			const int ret = usbhc_release_default_address(exch);
 			if (ret != EOK)
 				usb_log_warning("(%p-%u): Failed to release "
@@ -450,5 +451,5 @@
 		    port->port_number);
 		port->device_attached = true;
-		if (usb_release_default_address(exch) != EOK)
+		if (usbhc_release_default_address(exch) != EOK)
 			usb_log_warning("(%p-%u): Failed to release default "
 			    "address", hub, port->port_number);
Index: uspace/drv/bus/usb/usbhub/port.h
===================================================================
--- uspace/drv/bus/usb/usbhub/port.h	(revision d2d142afa611111d7d295ad56a4f3bba24d607f2)
+++ uspace/drv/bus/usb/usbhub/port.h	(revision f9d0a86c86defda4d9f30fbb4f7217a75048bf8b)
@@ -40,5 +40,4 @@
 #include <usb/dev/driver.h>
 #include <usb/classes/hub.h>
-#include <usb_iface.h>
 
 typedef struct usb_hub_dev usb_hub_dev_t;
Index: uspace/drv/bus/usb/usbhub/status.h
===================================================================
--- uspace/drv/bus/usb/usbhub/status.h	(revision d2d142afa611111d7d295ad56a4f3bba24d607f2)
+++ uspace/drv/bus/usb/usbhub/status.h	(revision f9d0a86c86defda4d9f30fbb4f7217a75048bf8b)
@@ -110,4 +110,5 @@
 	if ((status & USB_HUB_PORT_STATUS_HIGH_SPEED) != 0)
 		return USB_SPEED_HIGH;
+	/* TODO: add super speed */
 	return USB_SPEED_FULL;
 }
Index: uspace/drv/bus/usb/usbmid/main.c
===================================================================
--- uspace/drv/bus/usb/usbmid/main.c	(revision d2d142afa611111d7d295ad56a4f3bba24d607f2)
+++ uspace/drv/bus/usb/usbmid/main.c	(revision f9d0a86c86defda4d9f30fbb4f7217a75048bf8b)
@@ -147,4 +147,16 @@
 }
 
+static int usbmid_function_online(ddf_fun_t *fun)
+{
+	/* TODO: What if this is the control function? */
+	return ddf_fun_online(fun);
+}
+
+static int usbmid_function_offline(ddf_fun_t *fun)
+{
+	/* TODO: What if this is the control function? */
+	return ddf_fun_offline(fun);
+}
+
 /** USB MID driver ops. */
 static const usb_driver_ops_t mid_driver_ops = {
@@ -152,4 +164,6 @@
 	.device_rem = usbmid_device_remove,
 	.device_gone = usbmid_device_gone,
+	.function_online = usbmid_function_online,
+	.function_offline = usbmid_function_offline
 };
 
Index: uspace/drv/bus/usb/vhc/main.c
===================================================================
--- uspace/drv/bus/usb/vhc/main.c	(revision d2d142afa611111d7d295ad56a4f3bba24d607f2)
+++ uspace/drv/bus/usb/vhc/main.c	(revision f9d0a86c86defda4d9f30fbb4f7217a75048bf8b)
@@ -89,6 +89,5 @@
 
 	/* Initialize generic structures */
-	ret = hcd_ddf_setup_hc(dev, USB_SPEED_FULL,
-	    BANDWIDTH_AVAILABLE_USB11, bandwidth_count_usb11);
+	ret = hcd_ddf_setup_hc(dev);
 	if (ret != EOK) {
 		usb_log_error("Failed to init HCD structures: %s.\n",
@@ -98,5 +97,5 @@
 	}
 
-	hcd_set_implementation(dev_to_hcd(dev), data, &vhc_hc_ops);
+	hcd_set_implementation(dev_to_hcd(dev), data, &vhc_hc_ops, &data->bus.base);
 
 	/* Add virtual hub device */
@@ -112,5 +111,5 @@
 	 * needs to be ready at this time.
 	 */
-	ret = hcd_ddf_setup_root_hub(dev);
+	ret = hcd_setup_virtual_root_hub(dev_to_hcd(dev), dev);
 	if (ret != EOK) {
 		usb_log_error("Failed to init VHC root hub: %s\n",
Index: uspace/drv/bus/usb/vhc/transfer.c
===================================================================
--- uspace/drv/bus/usb/vhc/transfer.c	(revision d2d142afa611111d7d295ad56a4f3bba24d607f2)
+++ uspace/drv/bus/usb/vhc/transfer.c	(revision f9d0a86c86defda4d9f30fbb4f7217a75048bf8b)
@@ -31,4 +31,5 @@
 #include <usb/debug.h>
 #include <usbvirt/device.h>
+#include <usb/host/bandwidth.h>
 #include <usbvirt/ipc.h>
 #include "vhcd.h"
@@ -37,5 +38,5 @@
 static bool is_set_address_transfer(vhc_transfer_t *transfer)
 {
-	if (transfer->batch->ep->endpoint != 0) {
+	if (transfer->batch->target.endpoint != 0) {
 		return false;
 	}
@@ -43,9 +44,9 @@
 		return false;
 	}
-	if (usb_transfer_batch_direction(transfer->batch) != USB_DIRECTION_OUT) {
-		return false;
-	}
-	const usb_device_request_setup_packet_t *setup =
-	    (void*)transfer->batch->setup_buffer;
+	if (transfer->batch->dir != USB_DIRECTION_OUT) {
+		return false;
+	}
+	const usb_device_request_setup_packet_t *setup
+		= &transfer->batch->setup.packet;
 	if (setup->request_type != 0) {
 		return false;
@@ -62,11 +63,11 @@
 {
 	int rc;
-	
-	const usb_direction_t dir = usb_transfer_batch_direction(batch);
+
+	const usb_direction_t dir = batch->dir;
 
 	if (batch->ep->transfer_type == USB_TRANSFER_CONTROL) {
 		if (dir == USB_DIRECTION_IN) {
 			rc = usbvirt_control_read(dev,
-			    batch->setup_buffer, batch->setup_size,
+			    batch->setup.buffer, USB_SETUP_PACKET_SIZE,
 			    batch->buffer, batch->buffer_size,
 			    actual_data_size);
@@ -74,5 +75,5 @@
 			assert(dir == USB_DIRECTION_OUT);
 			rc = usbvirt_control_write(dev,
-			    batch->setup_buffer, batch->setup_size,
+			    batch->setup.buffer, USB_SETUP_PACKET_SIZE,
 			    batch->buffer, batch->buffer_size);
 		}
@@ -99,10 +100,10 @@
 	int rc;
 
-	const usb_direction_t dir = usb_transfer_batch_direction(batch);
+	const usb_direction_t dir = batch->dir;
 
 	if (batch->ep->transfer_type == USB_TRANSFER_CONTROL) {
 		if (dir == USB_DIRECTION_IN) {
 			rc = usbvirt_ipc_send_control_read(sess,
-			    batch->setup_buffer, batch->setup_size,
+			    batch->setup.buffer, USB_SETUP_PACKET_SIZE,
 			    batch->buffer, batch->buffer_size,
 			    actual_data_size);
@@ -110,5 +111,5 @@
 			assert(dir == USB_DIRECTION_OUT);
 			rc = usbvirt_ipc_send_control_write(sess,
-			    batch->setup_buffer, batch->setup_size,
+			    batch->setup.buffer, USB_SETUP_PACKET_SIZE,
 			    batch->buffer, batch->buffer_size);
 		}
@@ -148,7 +149,7 @@
 	assert(transfer);
 	assert(transfer->batch);
-	usb_transfer_batch_finish_error(transfer->batch, NULL,
-	    data_transfer_size, outcome);
-	usb_transfer_batch_destroy(transfer->batch);
+	transfer->batch->error = outcome;
+	transfer->batch->transfered_size = data_transfer_size;
+	usb_transfer_batch_finish(transfer->batch);
 	free(transfer);
 }
@@ -159,4 +160,5 @@
 	list_initialize(&instance->devices);
 	fibril_mutex_initialize(&instance->guard);
+	usb2_bus_init(&instance->bus, BANDWIDTH_AVAILABLE_USB11, bandwidth_count_usb11);
 	instance->magic = 0xDEADBEEF;
 	return virthub_init(&instance->hub, "root hub");
@@ -182,5 +184,5 @@
 	list_foreach(vhc->devices, link, vhc_virtdev_t, dev) {
 		fibril_mutex_lock(&dev->guard);
-		if (dev->address == transfer->batch->ep->address) {
+		if (dev->address == transfer->batch->target.address) {
 			if (!targets) {
 				list_append(&transfer->link, &dev->transfer_queue);
@@ -234,5 +236,5 @@
 			if (is_set_address_transfer(transfer)) {
 				usb_device_request_setup_packet_t *setup =
-				    (void*) transfer->batch->setup_buffer;
+				    (void*) transfer->batch->setup.buffer;
 				dev->address = setup->value;
 				usb_log_debug2("Address changed to %d\n",
Index: uspace/drv/bus/usb/vhc/vhcd.h
===================================================================
--- uspace/drv/bus/usb/vhc/vhcd.h	(revision d2d142afa611111d7d295ad56a4f3bba24d607f2)
+++ uspace/drv/bus/usb/vhc/vhcd.h	(revision f9d0a86c86defda4d9f30fbb4f7217a75048bf8b)
@@ -38,8 +38,8 @@
 
 #include <usbvirt/device.h>
-#include <usbhc_iface.h>
 #include <async.h>
 
 #include <usb/host/hcd.h>
+#include <usb/host/usb2_bus.h>
 
 #define NAME "vhc"
@@ -60,4 +60,5 @@
 	fibril_mutex_t guard;
 	usbvirt_device_t hub;
+	usb2_bus_t bus;
 } vhc_data_t;
 
Index: uspace/drv/bus/usb/xhci/Makefile
===================================================================
--- uspace/drv/bus/usb/xhci/Makefile	(revision f9d0a86c86defda4d9f30fbb4f7217a75048bf8b)
+++ uspace/drv/bus/usb/xhci/Makefile	(revision f9d0a86c86defda4d9f30fbb4f7217a75048bf8b)
@@ -0,0 +1,50 @@
+#
+# Copyright (c) 2017 Ondrej Hlavaty <aearsis@eideo.cz>
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+USPACE_PREFIX = ../../../..
+
+LIBS = usbhost usbvirt usb drv
+
+BINARY = xhci
+
+SOURCES = \
+	bus.c \
+	commands.c \
+	debug.c \
+	endpoint.c \
+	hc.c \
+	main.c \
+	rh.c \
+	scratchpad.c \
+	transfers.c \
+	trb_ring.c
+
+TEST_SOURCES = \
+	test/reg-ops.c
+
+include $(USPACE_PREFIX)/Makefile.common
Index: uspace/drv/bus/usb/xhci/bus.c
===================================================================
--- uspace/drv/bus/usb/xhci/bus.c	(revision f9d0a86c86defda4d9f30fbb4f7217a75048bf8b)
+++ uspace/drv/bus/usb/xhci/bus.c	(revision f9d0a86c86defda4d9f30fbb4f7217a75048bf8b)
@@ -0,0 +1,569 @@
+/*
+ * Copyright (c) 2017 Ondrej Hlavaty <aearsis@eideo.cz>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+/**  @addtogroup libusbhost
+ * @{
+ */
+/** @file
+ * HC Endpoint management.
+ */
+
+#include <usb/host/utils/malloc32.h>
+#include <usb/host/ddf_helpers.h>
+#include <usb/host/endpoint.h>
+#include <usb/host/hcd.h>
+#include <usb/debug.h>
+
+#include <assert.h>
+#include <errno.h>
+#include <str_error.h>
+#include <macros.h>
+#include <stdbool.h>
+
+#include "hc.h"
+#include "bus.h"
+#include "endpoint.h"
+#include "transfers.h"
+
+
+/* FIXME Are these really static? Older HCs fetch it from descriptor. */
+/* FIXME Add USB3 options, if applicable. */
+static const usb_endpoint_desc_t ep0_desc = {
+	.endpoint_no = 0,
+	.direction = USB_DIRECTION_BOTH,
+	.transfer_type = USB_TRANSFER_CONTROL,
+	.max_packet_size = CTRL_PIPE_MIN_PACKET_SIZE,
+	.packets = 1,
+};
+
+static int prepare_endpoint(xhci_endpoint_t *ep, const usb_endpoint_desc_t *desc)
+{
+	/* Extract information from endpoint_desc */
+	ep->base.endpoint = desc->endpoint_no;
+	ep->base.direction = desc->direction;
+	ep->base.transfer_type = desc->transfer_type;
+	ep->base.max_packet_size = desc->max_packet_size;
+	ep->base.packets = desc->packets;
+	ep->max_streams = desc->usb3.max_streams;
+	ep->max_burst = desc->usb3.max_burst;
+	// TODO add this property to usb_endpoint_desc_t and fetch it from ss companion desc
+	ep->mult = 0;
+
+	return xhci_endpoint_alloc_transfer_ds(ep);
+}
+
+static endpoint_t *create_endpoint(bus_t *base);
+
+static int address_device(xhci_hc_t *hc, xhci_device_t *dev)
+{
+	int err;
+
+	/* Enable new slot. */
+	if ((err = hc_enable_slot(hc, &dev->slot_id)) != EOK)
+		return err;
+	usb_log_debug2("Obtained slot ID: %u.\n", dev->slot_id);
+
+	/* Create and configure control endpoint. */
+	endpoint_t *ep0_base = create_endpoint(&hc->bus.base);
+	if (!ep0_base)
+		goto err_slot;
+
+	/* Temporary reference */
+	endpoint_add_ref(ep0_base);
+
+	xhci_endpoint_t *ep0 = xhci_endpoint_get(ep0_base);
+
+	if ((err = prepare_endpoint(ep0, &ep0_desc)))
+		goto err_ep;
+
+	/* Register EP0 */
+	if ((err = xhci_device_add_endpoint(dev, ep0)))
+		goto err_prepared;
+
+	/* Address device */
+	if ((err = hc_address_device(hc, dev, ep0)))
+		goto err_added;
+
+	/* Temporary reference */
+	endpoint_del_ref(ep0_base);
+	return EOK;
+
+err_added:
+	xhci_device_remove_endpoint(ep0);
+err_prepared:
+	xhci_endpoint_free_transfer_ds(ep0);
+err_ep:
+	/* Temporary reference */
+	endpoint_del_ref(ep0_base);
+err_slot:
+	hc_disable_slot(hc, dev);
+	return err;
+}
+
+int xhci_bus_enumerate_device(xhci_bus_t *bus, xhci_hc_t *hc, device_t *dev)
+{
+	int err;
+	xhci_device_t *xhci_dev = xhci_device_get(dev);
+
+	/* Manage TT */
+	if (dev->hub->speed == USB_SPEED_HIGH && usb_speed_is_11(dev->speed)) {
+		/* For LS devices under HS hub */
+		/* TODO: How about SS hubs? */
+		dev->tt.address = dev->hub->address;
+		dev->tt.port = dev->port;
+	}
+	else {
+		/* Inherit hub's TT */
+		dev->tt = dev->hub->tt;
+	}
+
+	/* Calculate route string */
+	xhci_device_t *xhci_hub = xhci_device_get(dev->hub);
+	xhci_dev->tier = xhci_hub->tier + 1;
+	xhci_dev->route_str = xhci_hub->route_str;
+
+	/* Roothub port is not part of the route string */
+	if (xhci_dev->tier >= 2) {
+		const unsigned offset = 4 * (xhci_dev->tier - 2);
+		xhci_dev->route_str |= (dev->port & 0xf) << offset;
+		xhci_dev->rh_port = xhci_hub->rh_port;
+	}
+
+	fibril_mutex_lock(&bus->base.guard);
+	/* Assign an address to the device */
+	if ((err = address_device(hc, xhci_dev))) {
+		usb_log_error("Failed to setup address of the new device: %s", str_error(err));
+		return err;
+	}
+
+	// TODO: Fetch descriptor of EP0 and reconfigure it accordingly
+	assert(xhci_dev->endpoints[0]);
+
+	assert(bus->devices_by_slot[xhci_dev->slot_id] == NULL);
+	bus->devices_by_slot[xhci_dev->slot_id] = xhci_dev;
+	fibril_mutex_unlock(&bus->base.guard);
+
+	/* Read the device descriptor, derive the match ids */
+	if ((err = hcd_ddf_device_explore(hc->hcd, dev))) {
+		usb_log_error("Device(%d): Failed to explore device: %s", dev->address, str_error(err));
+		goto err_address;
+	}
+
+	return EOK;
+
+err_address:
+	bus_release_address(&bus->base, dev->address);
+	return err;
+}
+
+static int unregister_endpoint(bus_t *, endpoint_t *);
+
+int xhci_bus_remove_device(xhci_bus_t *bus, xhci_hc_t *hc, device_t *dev)
+{
+	int err;
+	xhci_device_t *xhci_dev = xhci_device_get(dev);
+
+	/* Block creation of new endpoints and transfers. */
+	usb_log_debug2("Device " XHCI_DEV_FMT " going offline.", XHCI_DEV_ARGS(*xhci_dev));
+	fibril_mutex_lock(&dev->guard);
+	xhci_dev->online = false;
+	fibril_mutex_unlock(&dev->guard);
+
+	/* Abort running transfers. */
+	usb_log_debug2("Aborting all active transfers to device " XHCI_DEV_FMT ".", XHCI_DEV_ARGS(*xhci_dev));
+	for (size_t i = 0; i < ARRAY_SIZE(xhci_dev->endpoints); ++i) {
+		xhci_endpoint_t *ep = xhci_dev->endpoints[i];
+		if (!ep)
+			continue;
+
+		endpoint_abort(&ep->base);
+	}
+
+	/* TODO: Figure out how to handle errors here. So far, they are reported and skipped. */
+
+	/* Make DDF (and all drivers) forget about the device. */
+	if ((err = ddf_fun_unbind(dev->fun))) {
+		usb_log_warning("Failed to unbind DDF function of device " XHCI_DEV_FMT ": %s",
+		    XHCI_DEV_ARGS(*xhci_dev), str_error(err));
+	}
+
+	/* Disable the slot, dropping all endpoints. */
+	const uint32_t slot_id = xhci_dev->slot_id;
+	if ((err = hc_disable_slot(hc, xhci_dev))) {
+		usb_log_warning("Failed to disable slot of device " XHCI_DEV_FMT ": %s",
+		    XHCI_DEV_ARGS(*xhci_dev), str_error(err));
+	}
+
+	bus->devices_by_slot[slot_id] = NULL;
+
+	/* Unregister remaining endpoints, freeing memory. */
+	for (unsigned i = 0; i < ARRAY_SIZE(xhci_dev->endpoints); ++i) {
+		if (!xhci_dev->endpoints[i])
+			continue;
+
+		if ((err = unregister_endpoint(&bus->base, &xhci_dev->endpoints[i]->base))) {
+			usb_log_warning("Failed to unregister endpoint " XHCI_EP_FMT ": %s",
+			    XHCI_EP_ARGS(*xhci_dev->endpoints[i]), str_error(err));
+		}
+	}
+
+	/* Destroy DDF device. */
+	/* XXX: Not a good idea, this method should not destroy devices. */
+	hcd_ddf_device_destroy(dev);
+
+	return EOK;
+}
+
+/** Ops receive generic bus_t pointer. */
+static inline xhci_bus_t *bus_to_xhci_bus(bus_t *bus_base)
+{
+	assert(bus_base);
+	return (xhci_bus_t *) bus_base;
+}
+
+static int enumerate_device(bus_t *bus_base, hcd_t *hcd, device_t *dev)
+{
+	xhci_hc_t *hc = hcd_get_driver_data(hcd);
+	assert(hc);
+
+	xhci_bus_t *bus = bus_to_xhci_bus(bus_base);
+	assert(bus);
+
+	return xhci_bus_enumerate_device(bus, hc, dev);
+}
+
+static int remove_device(bus_t *bus_base, hcd_t *hcd, device_t *dev)
+{
+	xhci_hc_t *hc = hcd_get_driver_data(hcd);
+	assert(hc);
+
+	xhci_bus_t *bus = bus_to_xhci_bus(bus_base);
+	assert(bus);
+
+	return xhci_bus_remove_device(bus, hc, dev);
+}
+
+static int online_device(bus_t *bus_base, hcd_t *hcd, device_t *dev_base)
+{
+	int err;
+
+	xhci_hc_t *hc = hcd_get_driver_data(hcd);
+	assert(hc);
+
+	xhci_bus_t *bus = bus_to_xhci_bus(bus_base);
+	assert(bus);
+
+	xhci_device_t *dev = xhci_device_get(dev_base);
+	assert(dev);
+
+	/* Transition the device from the Addressed to the Configured state. */
+	if ((err = hc_configure_device(hc, dev->slot_id))) {
+		usb_log_warning("Failed to configure device " XHCI_DEV_FMT ".", XHCI_DEV_ARGS(*dev));
+	}
+
+	/* Block creation of new endpoints and transfers. */
+	usb_log_debug2("Device " XHCI_DEV_FMT " going online.", XHCI_DEV_ARGS(*dev));
+	fibril_mutex_lock(&dev_base->guard);
+	dev->online = true;
+	fibril_mutex_unlock(&dev_base->guard);
+
+	if ((err = ddf_fun_online(dev_base->fun))) {
+		return err;
+	}
+
+	return EOK;
+}
+
+static int offline_device(bus_t *bus_base, hcd_t *hcd, device_t *dev_base)
+{
+	int err;
+
+	xhci_hc_t *hc = hcd_get_driver_data(hcd);
+	assert(hc);
+
+	xhci_bus_t *bus = bus_to_xhci_bus(bus_base);
+	assert(bus);
+
+	xhci_device_t *dev = xhci_device_get(dev_base);
+	assert(dev);
+
+	/* Tear down all drivers working with the device. */
+	if ((err = ddf_fun_offline(dev_base->fun))) {
+		return err;
+	}
+
+	/* Block creation of new endpoints and transfers. */
+	usb_log_debug2("Device " XHCI_DEV_FMT " going offline.", XHCI_DEV_ARGS(*dev));
+	fibril_mutex_lock(&dev_base->guard);
+	dev->online = false;
+	fibril_mutex_unlock(&dev_base->guard);
+
+	/* We will need the endpoint array later for DS deallocation. */
+	xhci_endpoint_t *endpoints[ARRAY_SIZE(dev->endpoints)];
+	memcpy(endpoints, dev->endpoints, sizeof(dev->endpoints));
+
+	/* Remove all endpoints except zero. */
+	for (unsigned i = 1; i < ARRAY_SIZE(endpoints); ++i) {
+		if (!endpoints[i])
+			continue;
+
+		/* FIXME: Asserting here that the endpoint is not active. If not, EBUSY? */
+
+		xhci_device_remove_endpoint(endpoints[i]);
+	}
+
+	/* Issue one HC command to simultaneously drop all endpoints except zero. */
+	if ((err = hc_deconfigure_device(hc, dev->slot_id))) {
+		usb_log_warning("Failed to deconfigure device " XHCI_DEV_FMT ".",
+		    XHCI_DEV_ARGS(*dev));
+	}
+
+	/* Tear down TRB ring / PSA. */
+	for (unsigned i = 1; i < ARRAY_SIZE(endpoints); ++i) {
+		if (!endpoints[i])
+			continue;
+
+		xhci_endpoint_free_transfer_ds(endpoints[i]);
+	}
+
+	/* FIXME: What happens to unregistered endpoints now? Destroy them? */
+
+	return EOK;
+}
+
+static endpoint_t *create_endpoint(bus_t *base)
+{
+	xhci_bus_t *bus = bus_to_xhci_bus(base);
+
+	xhci_endpoint_t *ep = calloc(1, sizeof(xhci_endpoint_t));
+	if (!ep)
+		return NULL;
+
+	if (xhci_endpoint_init(ep, bus)) {
+		free(ep);
+		return NULL;
+	}
+
+	return &ep->base;
+}
+
+static void destroy_endpoint(endpoint_t *ep)
+{
+	xhci_endpoint_t *xhci_ep = xhci_endpoint_get(ep);
+
+	xhci_endpoint_fini(xhci_ep);
+	free(xhci_ep);
+}
+
+static int register_endpoint(bus_t *bus_base, device_t *device, endpoint_t *ep_base, const usb_endpoint_desc_t *desc)
+{
+	int err;
+	xhci_bus_t *bus = bus_to_xhci_bus(bus_base);
+	xhci_endpoint_t *ep = xhci_endpoint_get(ep_base);
+
+	xhci_device_t *dev = xhci_device_get(device);
+
+	if ((err = prepare_endpoint(ep, desc)))
+		return err;
+
+	if ((err = xhci_device_add_endpoint(dev, ep)))
+		goto err_prepared;
+
+	usb_log_info("Endpoint " XHCI_EP_FMT " registered to XHCI bus.", XHCI_EP_ARGS(*ep));
+
+	xhci_ep_ctx_t ep_ctx;
+	xhci_setup_endpoint_context(ep, &ep_ctx);
+
+	if ((err = hc_add_endpoint(bus->hc, dev->slot_id, xhci_endpoint_index(ep), &ep_ctx)))
+		goto err_added;
+
+	return EOK;
+
+err_added:
+	xhci_device_remove_endpoint(ep);
+err_prepared:
+	xhci_endpoint_free_transfer_ds(ep);
+	return err;
+}
+
+static int unregister_endpoint(bus_t *bus_base, endpoint_t *ep_base)
+{
+	int err;
+	xhci_bus_t *bus = bus_to_xhci_bus(bus_base);
+	xhci_endpoint_t *ep = xhci_endpoint_get(ep_base);
+	xhci_device_t *dev = xhci_device_get(ep_base->device);
+
+	usb_log_info("Endpoint " XHCI_EP_FMT " unregistered from XHCI bus.", XHCI_EP_ARGS(*ep));
+
+	xhci_device_remove_endpoint(ep);
+
+	/* If device slot is still available, drop the endpoint. */
+	if (dev->slot_id) {
+		if ((err = hc_drop_endpoint(bus->hc, dev->slot_id, xhci_endpoint_index(ep)))) {
+			usb_log_error("Failed to drop endpoint " XHCI_EP_FMT ": %s", XHCI_EP_ARGS(*ep), str_error(err));
+		}
+	} else {
+		usb_log_debug("Not going to drop endpoint " XHCI_EP_FMT " because"
+		    " the slot has already been disabled.", XHCI_EP_ARGS(*ep));
+	}
+
+	/* Tear down TRB ring / PSA. */
+	xhci_endpoint_free_transfer_ds(ep);
+
+	return EOK;
+}
+
+static endpoint_t* find_endpoint(bus_t *bus_base, device_t *dev_base, usb_target_t target, usb_direction_t direction)
+{
+	xhci_device_t *dev = xhci_device_get(dev_base);
+
+	xhci_endpoint_t *ep = xhci_device_get_endpoint(dev, target.endpoint);
+	if (!ep)
+		return NULL;
+
+	return &ep->base;
+}
+
+static int reset_toggle(bus_t *bus_base, usb_target_t target, toggle_reset_mode_t mode)
+{
+	// TODO: Implement me!
+	return ENOTSUP;
+}
+
+static size_t count_bw(endpoint_t *ep, size_t size)
+{
+	// TODO: Implement me!
+	return 0;
+}
+
+/* Endpoint ops, optional (have generic fallback) */
+static bool endpoint_get_toggle(endpoint_t *ep)
+{
+	// TODO: Implement me!
+	return ENOTSUP;
+}
+
+static void endpoint_set_toggle(endpoint_t *ep, bool toggle)
+{
+	// TODO: Implement me!
+}
+
+static int request_address(bus_t *bus_base, usb_address_t *addr, bool strict, usb_speed_t speed)
+{
+	assert(addr);
+
+	if (*addr != USB_ADDRESS_DEFAULT)
+		/* xHCI does not allow software to assign addresses. */
+		return ENOTSUP;
+
+	assert(strict);
+
+	xhci_bus_t *xhci_bus = bus_to_xhci_bus(bus_base);
+
+	if (xhci_bus->default_address_speed != USB_SPEED_MAX)
+		/* Already allocated */
+		return ENOENT;
+
+	xhci_bus->default_address_speed = speed;
+	return EOK;
+}
+
+static int release_address(bus_t *bus_base, usb_address_t addr)
+{
+	if (addr != USB_ADDRESS_DEFAULT)
+		return ENOTSUP;
+
+	xhci_bus_t *xhci_bus = bus_to_xhci_bus(bus_base);
+
+	xhci_bus->default_address_speed = USB_SPEED_MAX;
+	return EOK;
+}
+
+static usb_transfer_batch_t *create_batch(bus_t *bus, endpoint_t *ep)
+{
+	xhci_transfer_t *transfer = xhci_transfer_create(ep);
+	return &transfer->batch;
+}
+
+static void destroy_batch(usb_transfer_batch_t *batch)
+{
+	xhci_transfer_destroy(xhci_transfer_from_batch(batch));
+}
+
+static const bus_ops_t xhci_bus_ops = {
+#define BIND_OP(op) .op = op,
+	BIND_OP(enumerate_device)
+	BIND_OP(remove_device)
+
+	BIND_OP(online_device)
+	BIND_OP(offline_device)
+
+	BIND_OP(create_endpoint)
+	BIND_OP(destroy_endpoint)
+
+	BIND_OP(register_endpoint)
+	BIND_OP(unregister_endpoint)
+	BIND_OP(find_endpoint)
+
+	BIND_OP(request_address)
+	BIND_OP(release_address)
+	BIND_OP(reset_toggle)
+
+	BIND_OP(count_bw)
+
+	BIND_OP(endpoint_get_toggle)
+	BIND_OP(endpoint_set_toggle)
+
+	BIND_OP(create_batch)
+	BIND_OP(destroy_batch)
+#undef BIND_OP
+};
+
+int xhci_bus_init(xhci_bus_t *bus, xhci_hc_t *hc)
+{
+	assert(bus);
+
+	bus_init(&bus->base, sizeof(xhci_device_t));
+
+	bus->devices_by_slot = calloc(hc->max_slots, sizeof(xhci_device_t *));
+	if (!bus->devices_by_slot)
+		return ENOMEM;
+
+	bus->hc = hc;
+	bus->base.ops = xhci_bus_ops;
+	bus->default_address_speed = USB_SPEED_MAX;
+	return EOK;
+}
+
+void xhci_bus_fini(xhci_bus_t *bus)
+{
+
+}
+
+/**
+ * @}
+ */
